uses
  eco_novl
  
  ;


var
  count,
  conntype,
  mystation,
  retcode,
  total,
  logged     : integer;
  filler,
  net_number,
  node_addr,
  hexid,
  datetime,
  socket,
  realname,
  name       :  string;


begin
  filler := '                                          ';
  total := 0; logged := 0;
  getserverinfo; getstation(mystation,retcode);

  { Lets print a header for the top of our report }
  writeln('Connection Information for Server ',serverinfo.name);
  writeln;
  writeln('Station  Net      Node       User Name          Logged in     Real Name');
  writeln('   #   Address   Address                       Date & Time');
  for count := 1 to 79 do write('-'); writeln;
 
  { Lets scan through all posible connection numbers and see who is active }
  for count := 1 to serverinfo.connections_max do begin
    get_internet_address(count,net_number,node_addr,socket,retcode);
    if retcode=0 then begin {if retcode=0 then connection is active}
      getconnectioninfo(count,name,hexid,conntype,datetime,retcode);
      write(' ',count:3,' ');
      write(
        ' ',net_number,':',node_addr,'  ',copy(name+filler,1,15),' ',datetime
      );
       {if name is not blank, then lets see who is logged in}
      if name <> '' then begin
        get_realname(name,realname,retcode);
        writeln('  ',copy(realname+filler,1,16));
      end else writeln;
      inc(total);   {add 1 to total number of connections}
      if name<>'' then inc(logged); {add 1 to total number of logged-in stations}
    end;
  end;
  
  { Now that we have scanned all connection, lets print a summary report }
  writeln;
  write('Maximum Connections Allowed: ',serverinfo.connections_max:4);
  writeln('     Peak Connections Used: ',serverinfo.peak_connections_used);
  write('   Total connections in use: ',total:4);
  writeln('     Total USERS Logged in: ',logged);
end.


  This is a sample of how the unit can be used to print reports on the status
  of the network.

  Last updated:  10 Dec 90

  Mark Bramwell.
