{$UNDEF DEBUG}
{$A+,B-,E+,F-,N-,O-,R-,V-,I-}
{$IFDEF DEBUG} {$D+,L+,S+} {$ELSE} {$D-,L-,S-} {$ENDIF}
unit eco_adpt;

interface


type adaptertype = (none,mda,hercules,cga,egamono,egacolor,mcgamono,mcgacolor,
                    vgamono,vgacolor);


var checksnow          : boolean;     {for snow on cga}
    currenttextmode    : word;        {current video text mode}

    videopage          : byte;        {video page number}
    videocard          : adaptertype; {video kaart}
    maxrows            : byte;        {current max number of colums and lines}
    maxcols            : byte;
    videoofs           : word;        {offset video memory}
    videoseg           : word;        {start video memory}
    videoptr           : pointer absolute videoofs;
    startupmode        : word;        {videomode at startup time}
    startupcursorsize  : word;        {cursor size at startup time}

procedure initdetect; {will fill all vars with rigth values}

function  basescreen : word;

function  systemid : byte; {returns system id}

function  getvideopage : byte;
procedure setvideopage(page : byte);

function  getvideomode : word;
procedure settextmode(mode : integer);

function colormonitor : boolean;

(* cursor manipulation *)
function  getcursorshape : word;
procedure setcursorshape(scanlines : word);

(* desqview support *)
const in_dv : boolean = false;

function  dv_get_version : word;
function  dv_get_video_buffer(videoseg : word) : word;
procedure dv_pause;
procedure dv_begin_critical;
procedure dv_end_critical;

implementation

(*----------------- start externals ----------------------------------------*)
{$F+}

{$L GetVideo.OBJ}
function getvideocard : adaptertype; external;

{$L Vid-Mode.OBJ}
function getvideomode : word; external;
(* get the current videomode *)

{$L SetTxtMd.OBJ}
procedure settxtmode(mode : word); external;
(* set videomode *)

{$L Vid-Page.OBJ}
function  gettextpage : byte; external;
procedure settextpage(pageno : byte); external;

{$L GScrSize.OBJ}
procedure getscreensize(var rows,cols : byte); external;

{$L CurShape.OBJ}
function  getcursorshape : word; external;
procedure setcursorshape(scanlines : word); external;

{$L DesqView.OBJ}
function  dv_get_version; external;
function  dv_get_video_buffer; external;
procedure dv_pause; external;
procedure dv_begin_critical; external;
procedure dv_end_critical; external;

{$F-}
(*----------------- end externals ------------------------------------------*)

function basescreen : word;
var thistextmode : byte absolute $0040:$0049;
begin
 case thistextmode of
  7 : basescreen := $b000;
  else basescreen := $b800;
 end; {case}
end;

function getvideopage : byte;
begin
 videopage    := gettextpage;
 getvideopage := videopage;
                             { sizeof video screen }
 videoseg := basescreen + (videopage*memw[$0040:$004c] div 16);
 videoseg := dv_get_video_buffer(videoseg); { deze test als laatste ! }
end;

procedure setvideopage(page : byte);
begin
 settextpage(page);
 { dit hoeft eigenlijk niet want wordt gedaan door getvideopage }
 videopage := getvideopage;
end;

procedure settextmode(mode : integer);
begin
 settxtmode(mode);
 currenttextmode := getvideomode; {get real videomode}
 getscreensize(maxrows,maxcols);
 videopage := getvideopage;
end;

function colormonitor : boolean;
const co40 = 1;
      co80 = 3;
begin
 if (lo(currenttextmode) in [co40,co80]) then colormonitor := true
  else colormonitor := false;
end;

(*--------------------------------------------------------------------------*)

procedure initdetect; {will fill all vars with right values}
begin
 videocard       := getvideocard; {get videocard}

 currenttextmode := getvideomode; {    |verandert videoseg (wordt gebruikt }
 videopage       := getvideopage; { <=-|om videoseg te zetten)             }
 videoofs        := $0000;

 getscreensize(maxrows,maxcols); { get max rows (-1) and max cols }

 checksnow := (videocard = cga);
end;

function systemid : byte;
begin
 systemid := mem[$f000:$fffe];
end;



begin
 startupcursorsize := getcursorshape;
 startupmode       := getvideomode;
 initdetect;
end.
